VERSION 5.00
Begin VB.UserControl ctlTicker 
   ClientHeight    =   375
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2895
   ScaleHeight     =   375
   ScaleWidth      =   2895
   Begin VB.Timer tmrTicker 
      Left            =   0
      Top             =   0
   End
End
Attribute VB_Name = "ctlTicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Enumerated data values.
Enum tick_BorderStyle
    None_tick_BorderStyle = 0
    Fixed_Single_tick_BorderStyle = 1
End Enum

'Default Property Values:
Const m_def_Enabled = 0
Const m_def_AutoSize = 0
Const m_def_Caption = ""
Const m_def_RepeatSpacing = 0
Const m_def_XChange = 0
'Property Variables:
Dim m_Enabled As Boolean
Dim m_AutoSize As Boolean
Dim m_Caption As String
Dim m_RepeatSpacing As Integer
Dim m_XChange As Integer
'Event Declarations:
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."

Dim skip_redraw As Boolean

Dim X As Single
Dim CaptionWidth As Single


'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
    PropertyChanged "BackColor"
    DrawText    ' Redraw.
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    UserControl.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    m_Enabled = New_Enabled
    PropertyChanged "Enabled"

    ' Enable or disable if it's run time.
    If Ambient.UserMode Then _
        tmrTicker.Enabled() = New_Enabled
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Font
Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set UserControl.Font = New_Font
    PropertyChanged "Font"

    SizeControl ' Resize if necessary.
    DrawText    ' Redraw.
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
    SizeControl ' Resize if necessary.
End Property

Private Sub UserControl_Click()
    RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=0,0,0,0
Public Property Get AutoSize() As Boolean
Attribute AutoSize.VB_Description = "determines whether the control resizes itself to fit the text displayed"
    AutoSize = m_AutoSize
End Property

Public Property Let AutoSize(ByVal New_AutoSize As Boolean)
    m_AutoSize = New_AutoSize
    PropertyChanged "AutoSize"
    SizeControl ' Resize if necessary.
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=13,0,0,
Public Property Get Caption() As String
Attribute Caption.VB_Description = "the text displayed"
    Caption = m_Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    m_Caption = New_Caption
    PropertyChanged "Caption"

    CaptionWidth = TextWidth(m_Caption)
    If CaptionWidth > 0 And Ambient.UserMode Then
        tmrTicker.Enabled = m_Enabled
    Else
        tmrTicker.Enabled = False
    End If
    
    SizeControl ' Resize if necessary.
    DrawText    ' Redraw.
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=tmrTicker,tmrTicker,-1,Interval
Public Property Get Interval() As Long
Attribute Interval.VB_Description = "Returns/sets the number of milliseconds between calls to a Timer control's Timer event."
    Interval = tmrTicker.Interval
End Property

Public Property Let Interval(ByVal New_Interval As Long)
    tmrTicker.Interval() = New_Interval
    PropertyChanged "Interval"
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get RepeatSpacing() As Integer
Attribute RepeatSpacing.VB_Description = "the distance in pixels between ocurrences of the repeating caption"
    RepeatSpacing = m_RepeatSpacing
End Property

Public Property Let RepeatSpacing(ByVal New_RepeatSpacing As Integer)
    m_RepeatSpacing = New_RepeatSpacing
    PropertyChanged "RepeatSpacing"

    DrawText    ' Redraw.
End Property

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MemberInfo=7,0,0,0
Public Property Get XChange() As Integer
Attribute XChange.VB_Description = "the distance by which the text is moved when the interval expires"
    XChange = m_XChange
End Property

Public Property Let XChange(ByVal New_XChange As Integer)
    m_XChange = New_XChange
    PropertyChanged "XChange"
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    skip_redraw = True
    
    m_Enabled = m_def_Enabled
    Set UserControl.Font = Ambient.Font
    m_AutoSize = m_def_AutoSize
    m_Caption = m_def_Caption
    m_RepeatSpacing = m_def_RepeatSpacing
    m_XChange = m_def_XChange

    skip_redraw = False
    If Ambient.UserMode Then tmrTicker.Enabled = m_Enabled
    SizeControl ' Resize if necessary.
    DrawText    ' Redraw.
End Sub

Private Sub UserControl_Paint()
    DrawText
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    skip_redraw = True
    
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
    m_Enabled = PropBag.ReadProperty("Enabled", m_def_Enabled)
    Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    m_AutoSize = PropBag.ReadProperty("AutoSize", m_def_AutoSize)
    m_Caption = PropBag.ReadProperty("Caption", m_def_Caption)
    tmrTicker.Interval = PropBag.ReadProperty("Interval", 0)
    m_RepeatSpacing = PropBag.ReadProperty("RepeatSpacing", m_def_RepeatSpacing)
    m_XChange = PropBag.ReadProperty("XChange", m_def_XChange)

    skip_redraw = False
    If Ambient.UserMode Then tmrTicker.Enabled = m_Enabled
    SizeControl ' Resize if necessary.
    DrawText    ' Redraw.
End Sub

Private Sub UserControl_Resize()
    SizeControl ' Resize if necessary.
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, &H80000012)
    Call PropBag.WriteProperty("Enabled", m_Enabled, m_def_Enabled)
    Call PropBag.WriteProperty("Font", UserControl.Font, Ambient.Font)
    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
    Call PropBag.WriteProperty("AutoSize", m_AutoSize, m_def_AutoSize)
    Call PropBag.WriteProperty("Caption", m_Caption, m_def_Caption)
    Call PropBag.WriteProperty("Interval", tmrTicker.Interval, 0)
    Call PropBag.WriteProperty("RepeatSpacing", m_RepeatSpacing, m_def_RepeatSpacing)
    Call PropBag.WriteProperty("XChange", m_XChange, m_def_XChange)
End Sub

Private Sub DrawText()
    ' Do nothing if we're loading.
    If skip_redraw Then Exit Sub
    
    ' Start from scratch.
    Cls
    
    ' Do nothing if the text takes up no room.
    If CaptionWidth <= 0 Then Exit Sub
    
    ' Draw the text.
    CurrentX = X
    CurrentY = 0
    Do While CurrentX < ScaleWidth
        Print m_Caption;
        CurrentX = CurrentX + m_RepeatSpacing
    Loop
    
    ' Shift the starting position (if it's
    ' run time).
    If Not Ambient.UserMode Then Exit Sub
    X = X + m_XChange
    If m_XChange > 0 Then
        If X > 0 Then _
            X = -CaptionWidth - m_RepeatSpacing
    Else
        If X < -CaptionWidth Then _
            X = m_RepeatSpacing
    End If
End Sub
Private Sub SizeControl()
Static resizing As Boolean

    ' Do nothing if the caption is blank.
    CaptionWidth = TextWidth(m_Caption)
    If CaptionWidth <= 0 Then Exit Sub
    
    ' Do nothing unless AutoSize is True.
    If Not m_AutoSize Then Exit Sub
    
    ' Do not recurse.
    If resizing Then Exit Sub
    
    resizing = True
    Size ScaleX(TextWidth(m_Caption) - ScaleWidth, vbPixels, vbTwips) + Width, _
         ScaleY(TextHeight(m_Caption) - ScaleHeight, vbPixels, vbTwips) + Height
    resizing = False
    
    DrawText    ' Redraw.
End Sub
Private Sub tmrTicker_Timer()
    DrawText
End Sub

